/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreProcesstype.TCoreProcesstypePath;
import de.ship.db.tables.records.TCoreProcessvarRecord;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreProcessvar extends TableImpl<TCoreProcessvarRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_processvar</code>
     */
    public static final TCoreProcessvar T_CORE_PROCESSVAR = new TCoreProcessvar();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreProcessvarRecord> getRecordType() {
        return TCoreProcessvarRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_processvar.pk</code>.
     */
    public final TableField<TCoreProcessvarRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_processvar.fk_element</code>.
     */
    public final TableField<TCoreProcessvarRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_processvar.fk_processtype</code>.
     */
    public final TableField<TCoreProcessvarRecord, Integer> FK_PROCESSTYPE = createField(DSL.name("fk_processtype"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column
     * <code>common_dd.t_core_processvar.fk_referenced_element</code>.
     */
    public final TableField<TCoreProcessvarRecord, Integer> FK_REFERENCED_ELEMENT = createField(DSL.name("fk_referenced_element"), SQLDataType.INTEGER.nullable(false), this, "");

    private TCoreProcessvar(Name alias, Table<TCoreProcessvarRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreProcessvar(Name alias, Table<TCoreProcessvarRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_processvar</code> table
     * reference
     */
    public TCoreProcessvar(String alias) {
        this(DSL.name(alias), T_CORE_PROCESSVAR);
    }

    /**
     * Create an aliased <code>common_dd.t_core_processvar</code> table
     * reference
     */
    public TCoreProcessvar(Name alias) {
        this(alias, T_CORE_PROCESSVAR);
    }

    /**
     * Create a <code>common_dd.t_core_processvar</code> table reference
     */
    public TCoreProcessvar() {
        this(DSL.name("t_core_processvar"), null);
    }

    public <O extends Record> TCoreProcessvar(Table<O> path, ForeignKey<O, TCoreProcessvarRecord> childPath, InverseForeignKey<O, TCoreProcessvarRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_PROCESSVAR);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreProcessvarPath extends TCoreProcessvar implements Path<TCoreProcessvarRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreProcessvarPath(Table<O> path, ForeignKey<O, TCoreProcessvarRecord> childPath, InverseForeignKey<O, TCoreProcessvarRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreProcessvarPath(Name alias, Table<TCoreProcessvarRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreProcessvarPath as(String alias) {
            return new TCoreProcessvarPath(DSL.name(alias), this);
        }

        @Override
        public TCoreProcessvarPath as(Name alias) {
            return new TCoreProcessvarPath(alias, this);
        }

        @Override
        public TCoreProcessvarPath as(Table<?> alias) {
            return new TCoreProcessvarPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TCoreProcessvarRecord, Integer> getIdentity() {
        return (Identity<TCoreProcessvarRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreProcessvarRecord> getPrimaryKey() {
        return Keys.T_CORE_PROCESSVAR_PKEY;
    }

    @Override
    public List<UniqueKey<TCoreProcessvarRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_PROCESSVAR, Keys.UK_CORE_PROCESSVAR_REF);
    }

    @Override
    public List<ForeignKey<TCoreProcessvarRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_PROCESSVAR__T_CORE_PROCESSVAR_FK_ELEMENT_FKEY, Keys.T_CORE_PROCESSVAR__T_CORE_PROCESSVAR_FK_PROCESSTYPE_FKEY, Keys.T_CORE_PROCESSVAR__T_CORE_PROCESSVAR_FK_REFERENCED_ELEMENT_FKEY);
    }

    private transient TCoreElementHierarchyPath _tCoreProcessvarFkElementFkey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table, via the
     * <code>t_core_processvar_fk_element_fkey</code> key.
     */
    public TCoreElementHierarchyPath tCoreProcessvarFkElementFkey() {
        if (_tCoreProcessvarFkElementFkey == null)
            _tCoreProcessvarFkElementFkey = new TCoreElementHierarchyPath(this, Keys.T_CORE_PROCESSVAR__T_CORE_PROCESSVAR_FK_ELEMENT_FKEY, null);

        return _tCoreProcessvarFkElementFkey;
    }

    private transient TCoreProcesstypePath _tCoreProcesstype;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_processtype</code> table.
     */
    public TCoreProcesstypePath tCoreProcesstype() {
        if (_tCoreProcesstype == null)
            _tCoreProcesstype = new TCoreProcesstypePath(this, Keys.T_CORE_PROCESSVAR__T_CORE_PROCESSVAR_FK_PROCESSTYPE_FKEY, null);

        return _tCoreProcesstype;
    }

    private transient TCoreElementHierarchyPath _tCoreProcessvarFkReferencedElementFkey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table, via the
     * <code>t_core_processvar_fk_referenced_element_fkey</code> key.
     */
    public TCoreElementHierarchyPath tCoreProcessvarFkReferencedElementFkey() {
        if (_tCoreProcessvarFkReferencedElementFkey == null)
            _tCoreProcessvarFkReferencedElementFkey = new TCoreElementHierarchyPath(this, Keys.T_CORE_PROCESSVAR__T_CORE_PROCESSVAR_FK_REFERENCED_ELEMENT_FKEY, null);

        return _tCoreProcessvarFkReferencedElementFkey;
    }

    @Override
    public TCoreProcessvar as(String alias) {
        return new TCoreProcessvar(DSL.name(alias), this);
    }

    @Override
    public TCoreProcessvar as(Name alias) {
        return new TCoreProcessvar(alias, this);
    }

    @Override
    public TCoreProcessvar as(Table<?> alias) {
        return new TCoreProcessvar(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreProcessvar rename(String name) {
        return new TCoreProcessvar(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreProcessvar rename(Name name) {
        return new TCoreProcessvar(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreProcessvar rename(Table<?> name) {
        return new TCoreProcessvar(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcessvar where(Condition condition) {
        return new TCoreProcessvar(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcessvar where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcessvar where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcessvar where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreProcessvar where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreProcessvar where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreProcessvar where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreProcessvar where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcessvar whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreProcessvar whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
